"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSerializer = void 0;
var adt_builder_1 = require("./adt-builder");
var stringify = function (wrapper, data) {
    var toJson = function () { return (typeof data === 'undefined' ? '' : JSON.stringify(data)); };
    return adt_builder_1.isAdt(data) ? data.toString() : wrapper + "(" + toJson() + ")";
};
var createSerializer = function (wrapper, data) { return ({
    toJSON: function () {
        throw new Error("You are trying to serialize a " + stringify(wrapper, data) + ". Please fold it before doing it.");
    },
    toString: function () { return stringify(wrapper, data); },
}); };
exports.createSerializer = createSerializer;
//# sourceMappingURL=serializer.js.map